#   ____ _   _    _  _____    _        _
#  / ___| | | |  / \|_   _|__| |_ __ _| |_ ___
# | |   | |_| | / _ \ | |/ __| __/ _` | __/ __|
# | |___|  _  |/ ___ \| |\__ \ || (_| | |_\__ \
#  \____|_| |_/_/   \_\_||___/\__\__,_|\__|___/
#               3.0 by Baerchen, September 2001
#                  for eggdrop 1.4.x+ & TCL 8.3
#                     baerchen@germany-chat.net
#
# Read DESCRIPTION, CONFIGURATION & INSTALLATION.
# _Before_ complaining about bugs, make sure you have read all manuals.
# 
# CONFIGURATION

set cs(workdir) "/usr/home/bla/mybot/putallfileshere/"
set cs(trigger) "."
set cs(idle) 300
set cs(trimlimit) 0
set cs(global) {
 post=2
 timebalance=+0
 adinterval=0
 adsite=http://www.yoursitehere.com
 htmsuffix=.htm
 update=60
 ulmethod=1
 localfolder=/usr/home/bla/public_html/subdir/
 ftpname=www.myftp.com
 ftpport=21
 ftpfolder=/subdir/subdir/subdir/
 username=username
 password=password
}

# CODEBASE

bind pub - ${cs(trigger)}show cs:show
bind pub nC|C ${cs(trigger)}change cs:change
bind pub nC|C ${cs(trigger)}merge cs:merge
bind pub nC|C ${cs(trigger)}delete cs:delete
bind pub nC|C ${cs(trigger)}cyclestats cs:cycle
bind dcc nC|C go cs:go
bind dcc nC|C stop cs:stop
bind dcc n trim cs:trim
bind dcc n update cs:update
bind dcc n wipechan cs:wipechan
bind dcc n chatstats cs:status
bind dcc n back-up cs:backup
bind dcc n recover cs:recover
bind time - "18 * * * *" cs:autosave
bind time - "00 06 * * *" cs:autotrim
set cs(ver) "CHATstats 3.0 by Baerchen"

proc cs:ini {} {
 global cs csa csc csu numversion
 putlog "TCL LOADED: $cs(ver)"
 foreach e [timers] {if {[string match *cs:* $e]} {killtimer [lindex $e 2]}}
 array set csa ""; array set csc ""; array set csu ""
 if {![file isdirectory $cs(workdir)]} {file mkdir $cs(workdir)}
 if {![file exists $cs(workdir)CHATstats.dat]} {
  set fid [open $cs(workdir)CHATstats.dat w]
  puts $fid "CHATstats datafile v3.0\n--UserData--\n--ChannelData--\n--ActivityData--"
  close $fid
 }
 cs:read
 if {[file exists scripts/csconvertdb.tcl]} {
  source scripts/csconvertdb.tcl
  putlog "            Found csconvertdb.tcl, converting database .."
  cs:convertdb
 }
 foreach e [array names csc] {
  cs:changevars $e
  if {[lindex $csc($e) 0] == "yes"} {
   bind pubm - "$e *" cs:count; bind topc - "$e *" cs:topic; bind nick - "$e *" cs:nick
   bind join - "$e *" cs:join; bind rejn - "$e *" cs:join ; bind kick - "$e *" cs:kick 
   bind mode - "$e +b" cs:ban; bind splt - "$e *" cs:partquit; bind sign - "$e *" cs:partquit2 
   bind raw - PART cs:rawpart
   if {$numversion >= 1050000} {bind part - "$e *" cs:partquit2} else {bind part - "$e *" cs:partquit}
   if {$cs(update)} {
    timer $cs(update) "cs:html $e"
    if {$cs(adinterval)} {timer $cs(adinterval) "cs:advertize $e"}
   }
  }
 }
 set cs(ftperror) [catch {set cs(ftpclient) [exec which ftp]}]
 if {$cs(ftperror)} {
  if {[file executable /usr/bin/ftp]} {set cs(ftpclient) "/usr/bin/ftp"; set cs(ftperror) 0}
  if {[file executable /bin/ftp]} {set cs(ftpclient) "/bin/ftp"; set cs(ftperror) 0}
 }
 if {$cs(ftperror)} {putlog "            Error configuring FTP client."}
 cs:save; set cs(rehash) 1
}

proc cs:go {h idx a} {
 global botnick cs csa csc csu numversion
 set c [string tolower $a]
 if {![validchan $c] || ![botonchan $c]} {putdcc $idx "CHATstats: I'm not on $a."; return}
 if {[lsearch -exact [bind pubm - "$c *"] cs:count] == -1} {
  bind pubm - "$c *" cs:count; bind topc - "$c *" cs:topic; bind nick - "$c *" cs:nick
  bind join - "$c *" cs:join; bind rejn - "$c *" cs:join ; bind kick - "$c *" cs:kick 
  bind mode - "$c +b" cs:ban; bind splt - "$c *" cs:partquit; bind sign - "$c *" cs:partquit2
  bind raw - PART cs:rawpart
  if {$numversion >= 1050000} {bind part - "$c *" cs:partquit2} else {bind part - "$c *" cs:partquit}
 } else {putdcc $idx "CHATstats is already enabled for $c."; return}
 if {![info exists csa(00$c)]} {
  foreach e "00 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23" {set csa($e$c) 0}
  set csa(24$c) 1
 }
 if {![info exists csc($c)]} {set csc($c) "yes [unixtime] 0 0 [llength [chanlist $c]] [unixtime]"} else {
  set csc($c) [lreplace $csc($c) 0 0 "yes"];  set csc($c) [lreplace $csc($c) 2 2 0]
  if {[lindex $csc($c) 1] == 0} {set csc($c) [lreplace $csc($c) 1 1 [unixtime]]}
 }
 foreach e [chanlist $c] {
  if {([matchattr $e b]) || ($e == $botnick) || [string match -nocase "guest*" $e]} {continue}
  set el [cs:filter [string tolower $e]]
  if {[info exists csu($el$c)]} {
   set csu($el$c) [lreplace $csu($el$c) 0 0 [cs:filter $e]]; set csu($el$c) [lreplace $csu($el$c) 1 1 [unixtime]]
  } else {set csu($el$c) "[cs:filter $e] [unixtime] 1 0 0 0 0 0 0 0 0 0 0 0"}
 }
 cs:checkpeak $c; cs:save; putdcc $idx "CHATstats enabled for $c"; putlog "CHATstats enabled for $c ($h)."; cs:changevars $c
 if {$cs(update)} {
  timer $cs(update) "cs:html $c"
  if {$cs(adinterval)} {timer $cs(adinterval) "cs:advertize $c"}
 }
}

proc cs:stop {h idx a} {
 global cs csc numversion
 set c [string tolower $a]
 if {[lsearch -exact [bind pubm - "$c *"] cs:count] == -1} {putdcc $idx "CHATstats is not enabled for $c."; return}
 unbind pubm - "$c *" cs:count; unbind topc - "$c *" cs:topic; unbind nick - "$c *" cs:nick
 unbind join - "$c *" cs:join; unbind rejn - "$c *" cs:join ; unbind kick - "$c *" cs:kick 
 unbind mode - "$c +b" cs:ban; unbind splt - "$c *" cs:partquit; unbind sign - "$c *" cs:partquit2 
 if {$numversion >= 1050000} {unbind part - "$c *" cs:partquit2} else {unbind part - "$c *" cs:partquit}
 if {[info exists csc($c)]} {set csc($c) [lreplace $csc($c) 0 0 "no"]; set csc($c) [lreplace $csc($c) 2 2 [unixtime]]}
 foreach e [array names csu] {if {[string match *$c $e]} {cs:reset $e}}
 cs:save; cs:changevars $c; if {$cs(update)} {cs:html $c}
 foreach e [timers] {if {[string match *cs:*$c* $e]} {killtimer [lindex $e 2]}}
 putdcc $idx "CHATstats disabled for $c. Channel commands still available (except $cs(trigger)show)."
 putlog "CHATstats disabled for $c ($h)."
}

proc cs:join {n uh h c} {
 global cs csu botnick
 set ni [string tolower [cs:filter $n]]; set c [string tolower $c]; set j [llength [chanlist $c]]
 if {$n == $botnick} {bind raw - 353 cs:rawjoin; return}
 if {[matchattr $n b] || [string match -nocase "guest*" $n]} {return}
 if {[info exists csu($ni$c)]} {
  set csu($ni$c) [lreplace $csu($ni$c) 0 0 [cs:filter $n]]; set csu($ni$c) [lreplace $csu($ni$c) 1 1 [unixtime]]
  set csu($ni$c) [lreplace $csu($ni$c) 2 2 [expr [lindex $csu($ni$c) 2] + 1]]
 } else {set csu($ni$c) "[cs:filter $n] [unixtime] 1 0 0 0 0 0 0 0 0 0 0 0"}
 cs:checkpeak $c
}

proc cs:rawjoin {f k a} {
 global botnick cs csc csu
 set c [string tolower [lindex $a 2]]; set clist [lindex [split $a :] 1] 
 foreach e $clist {
  set e [string trimleft $e "%+@"]
  if {[matchattr $e b] || ($e == $botnick) || [string match -nocase "guest*" $e]} {continue}
  set el [cs:filter [string tolower $e]]
  if {[info exists csu($el$c)]} {
   set csu($el$c) [lreplace $csu($el$c) 0 0 [cs:filter $e]];  set csu($el$c) [lreplace $csu($el$c) 1 1 [unixtime]]
  } else {set csu($el$c) "[cs:filter $e] [unixtime] 1 0 0 0 0 0 0 0 0 0 0 0"}
 }
 return 0
}

proc cs:count {n uh h c t} {
 global botnick cs csa csu
 if {([matchattr $n b]) || ($n == $botnick) || [string match -nocase "guest*" $n]} {return}
 set ni [cs:filter [string tolower $n]]; set c [string tolower $c]
 set t [llength [split $t]]; set u [unixtime]
 if {[info exists csu($ni$c)]} {
  set csu($ni$c) [lreplace $csu($ni$c) 4 4 [expr [lindex $csu($ni$c) 4] + $t]]
  set csu($ni$c) [lreplace $csu($ni$c) 5 5 [expr [lindex $csu($ni$c) 5] + 1]]
  set ls [lindex $csu($ni$c) 12]; set idle [expr $u - $ls]
  if {($ls > 0) && ($idle > $cs(idle))} {
   set csu($ni$c) [lreplace $csu($ni$c) 13 13 [expr [lindex $csu($ni$c) 13] + $idle]]
   set csu($ni$c) [lreplace $csu($ni$c) 12 12 $u]
  } else {set csu($ni$c) [lreplace $csu($ni$c) 12 12 $u]}
 } else {set csu($ni$c) "[cs:filter $n] $u 1 0 $t 1 0 0 0 0 0 0 $u 0"}
 cs:changevars $c; incr csa([strftime "%H" $u]$c) $t
}

proc cs:nick {n uh h c ne} {
 set c [string tolower $c]
 cs:join $ne $uh $h $c; cs:partquit2 $n $uh $h $c ""
}

proc cs:kick {n uh h c t r} {
 global csu
 if {$n == "" } {return}
 set ni [string tolower [cs:filter $n]]; set c [string tolower $c]
 if {[info exists csu($ni$c)]} {set csu($ni$c) [lreplace $csu($ni$c) 8 8 [expr [lindex $csu($ni$c) 8] + 1]]}
 set ta [string tolower [cs:filter $t]]
 if {[info exists csu($ta$c)]} {cs:reset $ta$c; set csu($ta$c) [lreplace $csu($ta$c) 10 10 [expr [lindex $csu($ta$c) 10] + 1]]}
}

proc cs:ban {n uh h c mc v} {
 global cs csu
 if {$n == "" } {return}; set ni [string tolower [cs:filter $n]]; set c [string tolower $c]
 if {[info exists csu($ni$c)]} {set csu($ni$c) [lreplace $csu($ni$c) 9 9 [expr [lindex $csu($ni$c) 9] + 1]]}
 foreach e [chanlist $c] {
  if {[string match -nocase $v $e![getchanhost $e $c]]} {
   set vi [string tolower [cs:filter $e]]
   if {[info exists csu($vi$c)]} {set csu($vi$c) [lreplace $csu($vi$c) 11 11 [expr [lindex $csu($vi$c) 11] + 1]]}
  }
 }
}

proc cs:partquit {n uh h c} {cs:partquit2 $n $uh $h $c ""}
proc cs:partquit2 {n uh h c t} {
 global csu
 set ni [cs:filter [string tolower $n]]; set c [string tolower $c]; if {[info exists csu($ni$c)]} {cs:reset $ni$c}
}

proc cs:rawpart {f k a} {
 global botnick csc csu
 if {[lindex [split $f "!"] 0] == $botnick} {
 set c [string tolower $a]; foreach e [array names csu] {if {[string match *$c $e]} {cs:reset $e}}
 }
 cs:save; return 0
}

proc cs:show {n uh h c a} {
 global cs csc csu botnick
 set c [string tolower $c]; cs:changevars $c
 if {$cs(post) == 0} {puthelp "PRIVMSG $c: Stats not available. Go visit ${c}'s website $cs(adsite)."; return}
 if {![info exists csc($c)]} {return}
 set a [cs:filter $a]; set what [string tolower [lindex $a 0]]; set who [lindex $a 1]
 if {$who == ""} {set who [cs:filter $n]}
 switch -exact $what {
  channel    {set o "CHATstats for 04$c\n"; append o [cs:prep 0 1 $c ""]}
  joins      {set o "Top Joiners of 04$c\n"; append o [cs:prep 1 2 $c ""]}
  visitors   {set o "Top Visitors of 04$c\n"; append o [cs:prep 2 3 $c ""]}
  toptalkers {set o "Top Talkers of 04$c\n"; append o [cs:prep 1 4 $c ""]}
  stats      {set o ""; append o [cs:prep 3 4 $c $who]}
  allstars   {set o "Top AllStars of 04$c\n"; append o [cs:prep 1 6 $c ""]}
  kickers    {set o "Top Kickers of 04$c\n"; append o [cs:prep 1 8 $c ""]}
  banners       {set o "Top Banners of 04$c\n"; append o [cs:prep 1 9 $c ""]}
  kicked     {set o "Most famous victims of 04$c (Kicks)\n"; append o [cs:prep 1 10 $c ""]}
  banned     {set o "Most famous victims of 04$c (Bans)\n"; append o [cs:prep 1 11 $c ""]}
  idlers     {set o "Top Idlers of 04$c\n"; append o [cs:prep 2 13 $c ""]}
  titties    {set o "Hehe, I wish I had .."}
  default {
   puthelp "NOTICE $n :Usage: $cs(trigger)show <stats ?nick?|toptalkers|allstars|joins|visitors|idlers|kickers|kicked|banners|banned|channel>"
   puthelp "NOTICE $n :       e.g. $cs(trigger)show stats WhoEver or $cs(trigger)show channel"
   return
  }
 }
 set o [split $o "\n"]
 switch -exact $cs(post) {
   1 {foreach e $o {puthelp "PRIVMSG $c :[cs:defilter $e]"}}
   2 {foreach e $o {puthelp "NOTICE $n :[cs:defilter $e]"}}
   3 {foreach e $o {puthelp "PRIVMSG $n :[cs:defilter $e]"}}
 }
}

proc cs:prep {type sortfor c who} {
 global cs csc csu
 if {$type == 0} {
  foreach e "i j t wc wl k ku b bu id" {set $e 0}
  foreach e [array names csu] {
   if {[string match *$c $e]} {
    incr i; incr j  [lindex $csu($e) 2]; incr t [lindex $csu($e) 3]; incr wc [expr [lindex $csu($e) 4] + [lindex $csu($e) 6]]
    incr wl [expr [lindex $csu($e) 5] + [lindex $csu($e) 7]]; incr k  [lindex $csu($e) 8]; incr b [lindex $csu($e) 10]; incr id [lindex $csu($e) 13]
   }
  }
  if {$i == 0} {append o "Apparently, $c has no users. Try again later"; return $o}
  if {$k != 0} {set insert ", one kick every [cs:duration [expr $t/$k]])."} else {set insert ")."}
  regexp {\d{1,10}\..{2}} [expr $k/$i.0] ku; regexp {\d{1,10}\..{2}} [expr $b/$i.0] bu
  append o "Monitoring: [lindex $csc($c) 0]   Started: [cs:date $c sta]   Stopped: [cs:date $c sto]   Last cycle: [cs:date $c lr]\n"
  append o "Channel peak: [lindex $csc($c) 4] users on [cs:date $c peak]\n"
  append o "I've seen [cs:format $i] people joining [cs:format $j] times wasting [cs:duration $t].\n"
  append o "Their idletimes add up to [cs:duration $id] leaving [cs:duration [expr $t - $id]] of active chatting.\n"
  if {$wl > 0} {
   regexp {\d{1,10}\..{1}} [expr $wc/$wl.0] wla
   append o "All in all, people have spoken [cs:format $wc] words on [cs:format $wl] lines (avg $wla).\n"
  }
  append o "I count [cs:format $k] kicks/[cs:format $b] bans ($ku kicks/$bu bans per user$insert"
  return $o
 }
 set l ""
 foreach e [array names csu] {if {[string match *$c $e]} {lappend l "[lindex $csu($e) 0] [lindex $csu($e) $sortfor]"}}
 if {$l != ""} {set l [lsort -integer -decreasing -index 1 $l]} else {return "Insufficient data, please try again later"}
 if {$type == 1 || $type == 2} {
  for {set i 0} {$i<=9} {incr i} {
   set n [lindex [lindex $l $i] 0]; set r [lindex [lindex $l $i] 1]
   if {$n == "" || $r == 0} {append o "04[expr $i + 1]. N/A "; continue}
   if {$type == 2} { 
    if {$r < 3600} {
     set r [expr $r/60.0]; regexp {\d{1,10}\..{1}} $r r; set r "$r mins"} else {
     set r [expr $r/3600.0]; regexp {\d{1,10}\..{1}} $r r; set r "$r hrs"
    }
   }
   append o "04[expr $i + 1]. $n $r "
  }
  return $o
 }
 if {$type == 3} {
  set w [string tolower $who]
  if {![info exists csu($w$c)]} {return "No record about $who"}
  if {[onchan $who $c]} {
   set ts [expr [lindex $csu($w$c) 3] + ([unixtime] - [lindex $csu($w$c) 1]) ]} else {
   set ts [lindex $csu($w$c) 3]
  }
  set rc [expr [lsearch [string tolower $l] $w*] + 1]; set insert1 ""; set insert2 "";  ; set insert3 ""
  set cw [lindex $csu($w$c) 4]; set aw [lindex $csu($w$c) 6]
  if {$ts == 0} {set ts "N/A"} else {set insert3 "-> Active chatting: [cs:duration [expr $ts - [lindex $csu($w$c) 13]]]"; set ts "[cs:duration $ts] "}
  if {$cw > 0} {
   regexp {\d{1,3}\..{1}} [expr $cw.0/[lindex $csu($w$c) 5]] cwavg
   if {$rc > 1} {
    set rcp [expr $rc - 2]
    set insert1 "04[lindex [lindex $l $rcp] 0] is [expr [lindex [lindex $l $rcp] 1] - $cw] words ahead"
   }
  } else {set cwavg "N/A"; set rc "N/A"}
  if {$aw > 0} {
   regexp {\d{1,3}\..{1}} [expr $aw.0/[lindex $csu($w$c) 7]] awavg
   set l ""; foreach e [array names csu] {if {[string match *$c $e]} {lappend l "[lindex $csu($e) 0] [lindex $csu($e) 6]"}}
   if {$l != ""} {set l [lsort -integer -decreasing -index 1 $l]}
   set ra [expr [lsearch [string tolower $l] $w*] + 1]
   if {$ra > 1} {
    set rap [expr $ra - 2]
    set insert2 "04[lindex [lindex $l $rap] 0] is [expr [lindex [lindex $l $rap] 1] - $aw] words ahead"
   }
  } else {set awavg "N/A"; set ra "N/A"} 
  append o "Personal stats for 04$who on 04$c\n"
  append o "Joins: [lindex $csu($w$c) 2]   Time spent: $ts   Idle: [cs:duration [lindex $csu($w$c) 13]] $insert3\n"
  append o "TopTalkers: Rank $rc - $cw words/[lindex $csu($w$c) 5] lines (avg $cwavg). $insert1\n"
  append o "AllStars: Rank $ra - $aw words/[lindex $csu($w$c) 7] lines (avg $awavg). $insert2\n"
  append o "Kicks: [lindex $csu($w$c) 8]   Bans: [lindex $csu($w$c) 9]   Got kicked: [lindex $csu($w$c) 10]   Got banned: [lindex $csu($w$c) 11]"
  return $o
 }
}

proc cs:change {n uh h c a} {
 global cs csc csu
 set c [string tolower $c]; if {![info exists csc($c)]} {return}
 set a [cs:filter $a]; set what [lindex $a 0]
 if {[string match -nocase toptalker $what]} {set p 4; set q 5; set str "TopTalker"}
 if {[string match -nocase allstar $what]} {set p 6; set q 7; set str "AllStar"}
 if {![info exists p]} {puthelp "NOTICE $n :Usage: $cs(trigger)change toptalker|allstar <nick> <+|-amount>"; return}
 set ni [lindex $a 1]; set nic [string tolower $ni]; set value [lindex $a 2]
 if {[info exists csu($nic$c)]} { 
  if {[string is integer $value]} {
   set old [lindex $csu($nic$c) $p]; set lines [lindex $csu($nic$c) $q]; set new [expr $old + $value]
   if {$old > 0} {set x [expr $lines + int($value / ($old / $lines))]} else {set x [expr $lines + int($value / 4)]}
   if {$new < 0} {set new 0; set x 0; set value $old}
   set csu($nic$c) [lreplace $csu($nic$c) $p $p $new]; set csu($nic$c) [lreplace $csu($nic$c) $q $q $x]
   puthelp "NOTICE $n :Changed [cs:defilter $ni]'s $str balance from $old by $value to $new"
  } else {puthelp "NOTICE $n :Use an integer like +1000 or -500"}
 } else {puthelp "NOTICE $n :No record about [cs:defilter $ni] in $c"}
}

proc cs:merge {n uh h c a} {
 global cs csc csu
 set c [string tolower $c]; if {![info exists csc($c)]} {return}
 set a [cs:filter $a]; set from [lindex $a 0]; set i 2
 set froml [string tolower $from]; set to [lindex $a 1]; set tol [string tolower $to]
 if {[llength $a] != 2} {puthelp "NOTICE $n :Usage: $cs(trigger)merge <source-nick> <destination-nick>"; return}
 if {[info exists csu($froml$c)]} {
  if {[info exists csu($tol$c)]} {
   while {$i < 12} {set csu($tol$c) [lreplace $csu($tol$c) $i $i [expr [lindex $csu($froml$c) $i] + [lindex $csu($tol$c) $i]]]; incr i}
   set csu($tol$c) [lreplace $csu($tol$c) 13 13 [expr [lindex $csu($froml$c) 13] + [lindex $csu($tol$c) 13]]]
   unset csu($froml$c)
   puthelp "NOTICE $n :Merged [cs:defilter $from] in [cs:defilter $to], deleted [cs:defilter $from]"
  } else {puthelp "NOTICE $n :No record about [cs:defilter $to] in $c"}
 } else {puthelp "NOTICE $n :No record about [cs:defilter $from] in $c"}
}

proc cs:delete {n uh h c a} {
 global cs csc csu
 set c [string tolower $c]; if {![info exists csc($c)]} {return}
 if {$a == ""} {puthelp "NOTICE $n :Usage: $cs(trigger)delete <nick>"; return}
 set ni [cs:filter $a]; set nic [string tolower $ni]
 if {[info exists csu($nic$c)]} {unset csu($nic$c); puthelp "NOTICE $n :Deleted [cs:defilter $ni] in $c"} else {
  puthelp "NOTICE $n :No record about [cs:defilter $ni] in $c"
 }
}

proc cs:cycle {n uh h c a} {
 global cs csc csu
 set c [string tolower $c]; if {![info exists csc($c)]} {return}; set foobar 0
 if {[lsearch -exact [bind pubm - "$c *"] cs:count] > -1} {unbind pubm -|- "$c *" cs:count; set foobar 1}
 cs:save
 foreach e [array names csu] {
  set csu($e) [lreplace $csu($e) 6 6 [expr [lindex $csu($e) 6] + [lindex $csu($e) 4]]]
  set csu($e) [lreplace $csu($e) 7 7 [expr [lindex $csu($e) 7] + [lindex $csu($e) 5]]]
  set csu($e) [lreplace $csu($e) 4 4 0]; set csu($e) [lreplace $csu($e) 5 5 0]
 }
 set csc($c) [lreplace $csc($c) 3 3 [unixtime]]; cs:save; if {$foobar} {bind pubm - "$c *" cs:count}
 puthelp "PRIVMSG $c :CHATstats: Finished cycling TopTalkers."; putlog "CHATstats: Finished cycling TopTalkers ($h, $c)"
}

proc cs:status {h idx a} {
 global cs csa csc csu
 set bc ""; set i 0; set al "csa csc csu"
 foreach e $al {
  foreach el [array names $e] {
   set el "#[lindex [split $el #] 1]"
   if {[lsearch $bc $el] > -1} {incr i; continue}; if {![validchan $el]} {incr i; lappend bc $el}
  }
 }
 putdcc $idx "CHATstats Info:"
 if {$bc != ""} {
  putdcc $idx "\nI'm not on the following channel(s), which occupy $i entries in my databases:"
  putdcc $idx "$bc - You might want to use the command .wipechan"
 } else {
  putdcc $idx "\nAll databases seem to be clean - I can't find any orphaned entries"
 }
 putdcc $idx "Database size: [array size csu] entries   Trimlimit: $cs(trimlimit) words"
 putdcc $idx "\nIn detail, the following channel(s) are configured:"
 foreach e [array names csc] {
  set cname [string trimleft $e #]; set files ""; set cfiles ""; set gfiles ""; cs:changevars $e
  putdcc $idx " \n${e}"
  putdcc $idx " Monitoring: [lindex $csc($e) 0] / started: [cs:date $e sta] / stopped: [cs:date $e sto] / last cycle: [cs:date $e lr]"
  switch $cs(post) {
   0 {set y "None, I tell them to visit the website"}  1 {set y "PRIVMSG to channel"}
   2 {set y "NOTICE to user"} 3 {set y "PRIVMSG to user"}
  }
  putdcc $idx " Channel information: $y"
  putdcc $idx " Time correction: $cs(timebalance) hours, so right now it's [strftime %H:%M [expr [unixtime] + ($cs(timebalance) * 3600)]] from the user's POV."
  if {$cs(update)} {
   switch $cs(ulmethod) {
    0 {set y ", left in $cs(workdir)"} 1 {set y ", moved to $cs(localfolder)"}
    2 {set y ", uploaded to $cs(ftpname)$cs(ftpfolder) on port $cs(ftpport)"}
   }
   putdcc $idx " Webpage creation: yes$y"
   putdcc $idx " Interval: $cs(update) minutes"
   append cfiles "[glob -nocomplain -path $cs(workdir) *.${cname}.template] "
   append gfiles [glob -nocomplain -path $cs(workdir) *.global.template]
   foreach el $gfiles {
    set searchfor [string range $el 0 [string first "." $el]]
    if {[lsearch $cfiles $searchfor$cname.template] > -1} {set pos [lsearch $gfiles $el]; set gfiles [lreplace $gfiles $pos $pos]}
   }
   foreach el "$cfiles$gfiles" {lappend files [lindex [split $el "/"] end]}
   putdcc $idx " Templates in use: [join $files ", "]"
   if {$cs(adinterval)} {set adv "every $cs(adinterval) minutes"} else {set adv "no"}
   putdcc $idx " Advertisements: $adv"
  } else {putdcc $idx " Webpage creation: no"}
 }
 putdcc $idx "\nEnd of .chatstatus"
}

proc cs:read {} {
 global cs csa csc csu
 set fid [open $cs(workdir)CHATstats.dat r]; gets $fid l; gets $fid l
 if {![string match "--UserData--" $l]} {
  putlog "CHATstats: CHATstats.dat corrupted. Script not loaded properly."
  return
 }
 gets $fid l
 while {![string match "--ChannelData--" $l]} {
  if {![info exists cs(rehash)]} {
   set l [lreplace $l 1 1 0]; set l [lreplace $l 12 12 0]
   if {[lindex $l 3] > 900000000} {set l [lreplace $l 3 3 0]}
   if {[lindex $l 13] > [lindex $l 3]} {set l [lreplace $l 13 13 [lindex $l 3]]}
   set csu([string tolower [lindex $l 0]][lindex $l 14]) [lrange $l 0 13]
  }
  gets $fid l
 }
 gets $fid l
 while {![string match "--ActivityData--" $l]} {set csc([lindex $l 0]) [lrange $l 1 end]; gets $fid l}
 gets $fid l
 while {![eof $fid]} {
  if {![info exists cs(rehash)]} {
   set c [lindex $l 0]; set l [lrange $l 1 end]
   foreach e $l {set csa([lindex $e 0]$c) [lindex $e 1]}
  }
  gets $fid l
 }
 close $fid
 if {[info exists cs(recover)]} {set cs(rehash) 1}
}

proc cs:autosave {mi ho da mo ye} {cs:save}

proc cs:save {} {
 global cs csa csc csu
 set fid [open $cs(workdir)CHATstats.dat w]
 puts $fid "CHATstats datafile v3.0"
 puts $fid "--UserData--"
 if {[array exists csu]} {
  foreach e [array names csu] {puts $fid "$csu($e) #[lindex [split $e #] 1]"}
 }
 puts $fid "--ChannelData--"
 if {[array exists csc]} {
  foreach e [array names csc] {puts $fid "$e $csc($e)"}
 }
 puts $fid "--ActivityData--"
 if {[array exists csa]} {
  foreach e [array names csa] {lappend l(#[lindex [split $e #] 1]) "[lindex [split $e #] 0] $csa($e)"}
  foreach e [array names l] {puts $fid "$e $l($e)"}
 }
 close $fid
 if {![file exists $cs(workdir)CHATstats.backup]} {file copy -force $cs(workdir)CHATstats.dat $cs(workdir)CHATstats.backup}
}

proc cs:backup {h idx a} {
 global cs csa csc csu
 if {[file exists $cs(workdir)CHATstats.dat]} {
  file copy -force $cs(workdir)CHATstats.dat $cs(workdir)CHATstats.backup
  putdcc $idx "Copied CHATstats.dat to CHATstats.backup."
  } else {
  putdcc $idx "Can't find $cs(workdir)CHATstats.dat."
  return
 }
}

proc cs:recover {h idx a} {
 global cs csa csc csu
 if {![file exists $cs(workdir)CHATstats.backup]} {
  putdcc $idx "Can't find file $cs(workdir)CHATstats.backup, aborting."
  return
 }
 if {[array exists csa]} {unset csa}
 if {[array exists csc]} {unset csc}
 if {[array exists csu]} {unset csu}
 file copy -force $cs(workdir)CHATstats.backup $cs(workdir)CHATstats.dat
 unset cs(rehash); set cs(recover) 1; cs:read; unset cs(recover)
 putdcc $idx "Data loaded from CHATstats.backup."
}

proc cs:wipechan {h idx a} {
 global cs csa csc csu
 set c [string tolower $a]
 if {$c == ""} {putdcc $idx "Usage: .wipechan <channel>"; return}
 if {[lsearch -exact [bind pubm - "$c *"] cs:count] > -1} {
  putdcc $idx "CHATstats is enabled on ${a}. Use \"stop $a\" first."
  return
 }
 foreach e [timers] {if {[string match *cs:*$c* $e]} {killtimer [lindex $e 2]}}
 array unset csa *$c; array unset csc $c; array unset csu *$c; cs:save
 putdcc $idx "Done. Deleted channel $a from all databases."
}

proc cs:trim {h idx a} {
 global csu
 set foo 0; set bar [array size csu]
 if {![string is integer $a]} {putdcc $idx "Can't trim by $a. Use an integer > 0"; return}
 foreach e [array names csu] {if {([lindex $csu($e) 4] < $a) && ([lindex $csu($e) 6] < $a)} {unset csu($e); incr foo}}
 cs:save
 if {$idx == -1} {putlog "CHATstats: Trimmed database, $foo of $bar users have been removed."} else { 
  putdcc $idx "Trimmed database, $foo of $bar users have been removed."
 }
}

proc cs:autotrim {mi ho da mo ye} {
 global cs
 cs:trim "CHATstats" "-1" $cs(trimlimit)
}

proc cs:advertize {c} {
 global cs
 cs:changevars $c
 puthelp "PRIVMSG $c :I create diverse statistics for ${c}. Go visit $cs(adsite)."
 if {$cs(update) && $cs(adinterval)} {timer $cs(adinterval) "cs:advertize $c"}
}

proc cs:update {h idx a} {
 global cs
 set c [string tolower $a]; set l ""
 foreach e [binds cs:count] {
  regexp {#.*?\s} $e e; set e [string trim $e]; cs:changevars $e
  if {$cs(update)} {if {![validchan $e] || ![botonchan $e]} {putdcc $idx "I'm not on ${e}."; continue}; lappend l $e}
 }
 if {[llength $l] == 0} {putdcc $idx "No channels enabled or I'm not on any of the enabled channels at the moment"; return}
 set l [lsort $l]
 if {$c == ""} {
  putdcc $idx "Updating webpages for [join $l ", "]"
  foreach e $l {
   cs:changevars $e; foreach el [timers] {if {[string match "*cs:html $e*" $el]} {killtimer [lindex $el 2]}}; cs:html $e
  }
 } else {
  if {![validchan $c] || ![botonchan $c]} {putdcc $idx "I'm not on ${c}."; return}
  if {[lsearch $l $c] == -1} {putdcc $idx "CHATstats is not enabled in $c"; return}
  if {$cs(update)} {
   foreach e [timers] {if {[string match "*cs:html $c*" $e]} {killtimer [lindex $e 2]}}
   putdcc $idx "Updating webpages for $c"; cs:html $c
  } else {putdcc $idx "Configuration does not allow to create webpages for $c"}
 }
} 

proc cs:html {c} {
 global cs csa csc cstemp1 cstemp2 csu
 cs:save; set cname [string trimleft $c #]; set ullist ""; set cfiles ""; set gfiles ""; cs:changevars $c
 if {![botonchan $c]} {
  putlog "Skipped creating webpages for $c. I'm not on that channel."
  if {$cs(update)} {timer $cs(update) "cs:html $c"}; return
 }
 if {$cs(ftperror) && $cs(ulmethod) == 2} {
  putlog "Skipped creating webpages for $c due to an FTP configuration error"; return
 }
 if {[array exists cstemp1]} {unset cstemp1}
 append cfiles "[glob -nocomplain -path $cs(workdir) *.${cname}.template] "
 append gfiles [glob -nocomplain -path $cs(workdir) *.global.template]
 foreach e $gfiles {
  set searchfor [string range $e 0 [string first "." $e]]
  if {[lsearch $cfiles $searchfor$cname.template] > -1} {set pos [lsearch $gfiles $e]; set gfiles [lreplace $gfiles $pos $pos]}
 }
 set files "$cfiles$gfiles"
 if {$files == ""} {
  putlog "Skipped creating webpages for $c. There are no templates in $cs(workdir)."
  if {$cs(update)} {timer $cs(update) "cs:html $c"}
  return  
 }
 foreach e $files {
  set output "[string range $e 0 [string first "." $e]]$cname$cs(htmsuffix)"; cs:create $c $e $output; lappend ullist $output
 }
 if {[array exists cstemp2]} {unset cstemp2}
 if {$ullist != ""} {
  switch -exact $cs(ulmethod) {
   1 {foreach e $ullist {
       if {[file exists $e]} {file copy -force $e $cs(localfolder); file delete -force $e} else {
        putlog "CHATstats: Skipped moving ${e}, file not found."
       }
      }
     }
   2 {set ftperror [catch {
       set ftpid [open "|$cs(ftpclient) -n $cs(ftpname) $cs(ftpport)" w]
       puts $ftpid "user $cs(username) $cs(password)"
       foreach a $ullist {
        if {[file exists $a]} {
         puts $ftpid "put $a $cs(ftpfolder)[lindex [split $a "/"] end]"
        } else {putlog "CHATstats: Skipped uploading ${a}, file not found."}
       }
       puts $ftpid "quit"
       close $ftpid
      }]
      if {$ftperror} {putlog "CHATstats: An error occured while trying to use FTP."}
      foreach a $ullist {file delete -force $a}
     }
  }
 }
 if {$cs(update)} {timer $cs(update) "cs:html $c"}
}

proc cs:create {c input output} {
 global cs csa csc csu cstemp1 cstemp2 cst botnick offset timezone uptime server {server-online}
 if {![array exists cstemp2]} {
  set cstemp2(plusers) ""; set cstemp2(ulink) "None"
  if {[llength [bots]] > 0} {set cstemp2(bots) [join [lsort -dictionary [bots]] ", "]} else {set cstemp2(bots) "None"}
  foreach e [whom *] {if {$e != ""} {lappend cstemp2(plusers) [cs:filter "[lindex $e 0] [lindex $e 1] [lindex $e 6]"]}}
  set cstemp2(plusers) [lsort -dictionary $cstemp2(plusers)]
  foreach e [bots] {
   if {([validuser $e]) && ([string match *h* [getuser $e BOTFL]]) && ([islinked $e])} {set cstemp2(ulink) [cs:filter $e]}
   if {([validuser $e]) && ([matchattr $e b]) && (![string match *h* [getuser $e BOTFL]]) && ([islinked $e])} {lappend cstemp2(dlinks) [cs:filter $e]}
  }
  if {[info exists cstemp2(dlinks)]} {set cstemp2(dlinks) [join [lsort -dictionary $cstemp2(dlinks)] ", "]} else {set cstemp2(dlinks) "None"}
 }
 if {![array exists cstemp1]} {
  set cstemp1(all) 0; set cstemp1(ops) 0; set cstemp1(vos) 0; set cstemp1(chuserlist) ""; set oplist ""; set volist ""; set uslist ""
  set cstemp1(chanbans) ""; set topic [cs:filtertopic [topic $c]]; set topicline "";
  foreach e "ttoptalkers tallstars tjoins totime ttwords ttlines tawords talines tkicks tbans titime" {set cstemp1($e) 0}
  foreach e [chanlist $c] {
   incr cstemp1(all)
   if {[isop $e $c]} {incr cstemp1(ops); set e "@[cs:filter $e]"; lappend oplist $e; continue}
   if {[isvoice $e $c]} {incr cstemp1(vos); set e "+[cs:filter $e]"; lappend volist $e; continue}
   set e " [cs:filter $e]"; lappend uslist $e
  }
  set cstemp1(chuserlist) [append cstemp1(chuserlist) " [lsort -dictionary $oplist]" " [lsort -dictionary $volist]" " [lsort -dictionary $uslist]"]
  set cstemp1(nos) [expr $cstemp1(all) - ($cstemp1(ops) + $cstemp1(vos))]; set cstemp1(nosp) [expr ($cstemp1(nos) * 100) / $cstemp1(all)]
  set cstemp1(vosp) [expr ($cstemp1(vos) * 100) / $cstemp1(all)]; set cstemp1(opsp) [expr ($cstemp1(ops) * 100) / $cstemp1(all)]
  foreach e [chanbans $c] {lappend cstemp1(chanbans) "[lindex [split $e] 0]"}; set cstemp1(chanbans) [lsort -dictionary $cstemp1(chanbans)]
  if {![info exists cst($c)]} {set cst($c) "N/A"}
  # regsub -all "(.{50}\[^http://\])" $topic {\1<BR>} topic
  # personal hack to \n a topic without spaces after 50 chars if it doesn't contain a link
  foreach e [split $topic] {
   if {[string match "http://*" $e]} {set el $e; regsub -all "<BR>" $e "" e; append topicline " <A HREF=\"$e\">$el</A>"
   } else {append topicline " $e"}
  }
  set cstemp1(topic) $topicline
  if {![info exists timezone] || $timezone == ""} {set timezone "N/A"}; if {![info exists offset] || $offset == ""} {set offset "N/A"}
  foreach e [array names csu] {
   if {[string match *$c $e]} {
    if {[lindex $csu($e) 4] > 0} {incr cstemp1(ttoptalkers)}
    if {[lindex $csu($e) 6] > 0} {incr cstemp1(tallstars)}
    incr cstemp1(tjoins) [lindex $csu($e) 2]; incr cstemp1(totime) [lindex $csu($e) 3]; incr cstemp1(ttwords) [lindex $csu($e) 4]
    incr cstemp1(ttlines) [lindex $csu($e) 5]; incr cstemp1(tawords) [lindex $csu($e) 6]; incr cstemp1(talines) [lindex $csu($e) 7]
    incr cstemp1(tkicks)  [lindex $csu($e) 8]; incr cstemp1(tbans) [lindex $csu($e) 10]; incr cstemp1(titime) [lindex $csu($e) 13]
   }
  } 
 }
 set fid [open $input r]; set html [open $output w]
 while {![eof $fid]} {
  gets $fid l; set i 0
  while {[string match "*%%*" $l]} {
   if {$i > 100} {
    putlog "An error occured in template [lindex [split $input "/"] end] .. most likely a variable has a wrong name. Line:"
    putlog "$l"; break
   }
   switch -glob $l {
    *%%TOPTALKERSAMOUNT* {regsub -all %%TOPTALKERSAMOUNT $l [cs:format $cstemp1(ttoptalkers)] l}
    *%%TOPTALKERSWORDS* {regsub -all %%TOPTALKERSWORDS $l [cs:format $cstemp1(ttwords)] l}
    *%%TOPTALKERSLINES* {regsub -all %%TOPTALKERSLINES $l [cs:format $cstemp1(ttlines)] l}
    *%%TOPTALKERSRATIO* {set x [expr $cstemp1(ttwords).0 / ($cstemp1(ttlines) + 1)]; regexp {\d+\..{1}} $x x; regsub -all %%TOPTALKERSRATIO $l $x l}
    *%%ALLSTARSAMOUNT* {regsub -all %%ALLSTARSAMOUNT $l [cs:format $cstemp1(tallstars)] l}    
    *%%ALLSTARSWORDS* {regsub -all %%ALLSTARSWORDS $l [cs:format $cstemp1(tawords)] l}
    *%%ALLSTARSLINES* {regsub -all %%ALLSTARSLINES $l [cs:format $cstemp1(talines)] l}
    *%%ALLSTARSRATIO* {set x [expr $cstemp1(tawords).0 / ($cstemp1(talines) + 1)]; regexp {\d+\..{1}} $x x; regsub -all %%ALLSTARSRATIO $l $x l}
    *%%TWORDS* {regsub -all %%TWORDS $l [cs:format [expr $cstemp1(ttwords) + $cstemp1(tawords)]] l}
    *%%TLINES* {regsub -all %%TLINES $l [cs:format [expr $cstemp1(ttlines) + $cstemp1(talines)]] l}
    *%%TOTALJOINS* {regsub -all %%TOTALJOINS $l [cs:format $cstemp1(tjoins)] l}
    *%%TOTALONLINE* {regsub -all %%TOTALONLINE $l [cs:duration $cstemp1(totime)] l}
    *%%TOTALKICKS* {regsub -all %%TOTALKICKS $l [cs:format $cstemp1(tkicks)] l}
    *%%TOTALBANS* {regsub -all %%TOTALBANS $l [cs:format $cstemp1(tbans)] l}
    *%%TOTALIDLE* {regsub -all %%TOTALIDLE $l [cs:duration $cstemp1(titime)] l}
    *%%CHANNEL* {regsub -all %%CHANNEL $l $c l}
    *%%TIMEBALANCE* {regsub -all %%TIMEBALANCE $l $cs(timebalance) l}
    *%%TIMENOW* {regsub -all %%TIMENOW $l [cs:date $c admyhm] l}
    *%%TIMENEXTUPDATE* {regsub -all %%TIMENEXTUPDATE $l [strftime %H:%M [expr [unixtime] + ($cs(timebalance) * 3600) + ($cs(update) * 60)]] l}
    *%%CHANTOPIC* {regsub -all %%CHANTOPIC $l $cstemp1(topic) l}
    *%%CHANTOPSETTER* {regsub -all %%CHANTOPSETTER $l $cst($c) l}
    *%%CHANMODES* {regsub -all %%CHANMODES $l [getchanmode $c] l}
    *%%CHANUSERS* {regsub -all %%CHANUSERS $l $cstemp1(all) l}
    *%%CHANOPS* {regsub -all %%CHANOPS $l $cstemp1(ops) l}
    *%%CHANVOICES* {regsub -all %%CHANVOICES $l $cstemp1(vos) l}
    *%%CHANOTHERS* {regsub -all %%CHANOTHERS $l $cstemp1(nos) l}
    *%%CHAN%USERS* {regsub -all %%CHAN%USERS $l "100%" l}
    *%%CHAN%OPS* {regsub -all %%CHAN%OPS $l "$cstemp1(opsp)%" l}
    *%%CHAN%VOICES* {regsub -all %%CHAN%VOICES $l "$cstemp1(vosp)%" l}
    *%%CHAN%OTHERS* {regsub -all %%CHAN%OTHERS $l "$cstemp1(nosp)%" l}
    *%%SCRIPTSTATUS* {regsub -all %%SCRIPTSTATUS $l [lindex $csc($c) 0] l}
    *%%SCRIPTSTARTED* {regsub -all %%SCRIPTSTARTED $l [cs:date $c sta] l}
    *%%SCRIPTSTOPPED* {regsub -all %%SCRIPTSTOPPED $l [cs:date $c sto] l}
    *%%SCRIPTCYCLE* {regsub -all %%SCRIPTCYCLE $l [cs:date $c lr] l}
    *%%BOTNICK* {regsub -all %%BOTNICK $l $botnick l}
    *%%BOTIRCSERVER* {regsub -all %%BOTIRCSERVER $l $server l}
    *%%BOTONLINE* {regsub -all %%BOTONLINE $l [cs:duration [expr [unixtime] - ${server-online}]] l}
    *%%BOTNETBOTS* {regsub -all %%BOTNETBOTS $l $cstemp2(bots) l}
    *%%BOTNETSIZE* {regsub -all %%BOTNETSIZE $l [cs:format [llength $cstemp2(bots)]] l}
    *%%BOTNETUSERS* {regsub -all %%BOTNETUSERS $l [cs:format [llength $cstemp2(plusers)]] l}
    *%%BOTUSERLIST* {regsub -all %%BOTUSERLIST $l [cs:format [countusers]] l}    
    *%%BOTUPLINK* {regsub -all %%BOTUPLINK $l [cs:defilter $cstemp2(ulink)] l}
    *%%BOTDOWNLINKS* {regsub -all %%BOTDOWNLINKS $l [cs:defilter $cstemp2(dlinks)] l}
    *%%BOTUPTIME* {regsub -all %%BOTUPTIME $l [cs:duration [expr [unixtime] - $uptime]] l}
    *%%BOTOFFSET* {regsub -all %%BOTOFFSET $l $offset l}
    *%%BOTTIMEZONE* {regsub -all %%BOTTIMEZONE $l $timezone l}
   }
  incr i
  }
  if {[string match -nocase "<!--*-->" $l]} {
   set what ""; set width 0; set amount 0
   regexp {(\w+)\s(\d+)?,?(\d+)?} $l match what width amount
   set what [string tolower $what]; set eoc 0; set rep1 ""; set list ""
   while {!$eoc} {gets $fid nl; if {[string match -nocase "<!--*end of ${what}*-->" $nl] || [eof $fid]} {set eoc 1} else {lappend rep1 [split $nl]}}
   switch -glob $what {
    partyline {
     foreach e $cstemp2(plusers) {
      regsub -all !!USER $rep1 [lindex $e 0] rep2; regsub -all !!BOT $rep2 [lindex $e 1] rep2; regsub -all !!CHAN $rep2 [lindex $e 2] rep2
      puts $html [cs:defilter [join [join $rep2]]]
     }
     continue
    } 
    bans {
     for {set i 0} {$i <= [llength $cstemp1(chanbans)]} {incr i} {
      regsub !!BAN $rep1 [lindex $cstemp1(chanbans) $i] rep2
      while {[string match *!!BAN* $rep2]} {incr i; regsub !!BAN $rep2 [lindex $cstemp1(chanbans) $i] rep2}
      puts $html [cs:defilter [join [join $rep2]]]
     }
     continue
    }
    activity {
     if {$width == 0} {
      putlog "CHATstats: Syntax error in $input, must be: <!-- activity WidthOfBar,0  -->"
      continue
     }
     foreach e [array names csa] {if {[string match *$c $e]} {lappend list "[lindex [split $e #] 0] $csa($e)"}}
     set total 0; foreach e $list {incr total [lindex $e 1]}; set list [lsort -integer -decreasing -index 1 $list]
     set max [expr ([lindex [lindex $list 0] 1] * 100.0)/$total]; set list [lsort -increasing -index 0 $list]
     for {set i 0} {$i < 24} {incr i} {
      set int [lindex [lindex $list $i] 1]; set x [expr ($int * 100.0)/$total]
      regexp {\d{1,3}\..{1}} $x x; set barlength [expr int($x * ($width / $max) + ($x / 10))]
      regsub !!TIME1 $rep1 "[lindex [lindex $list $i] 0]:00" rep2
      regsub !!TIME2 $rep2 "[lindex [lindex $list [expr $i + 1]] 0]:00" rep2
      regsub !!VALUE $rep2 $int rep2
      regsub !!PERCENT $rep2 "${x}%" rep2
      regsub !!WIDTH $rep2 $barlength rep2
      puts $html [join [join $rep2]]
     }
     continue
    }
    chanusers {
     foreach n $cstemp1(chuserlist) {
      set n [cs:defilter $n]; regsub -all "!!USER" $rep1 $n rep2;
      set n [string range $n 1 end]; regsub -all "!!HOST" $rep2 [string range [getchanhost $n] 0 45] rep2
      set gcj [getchanjoin $n $c]; set u [unixtime]
      if {$gcj > 0} {regsub -all "!!DUR" $rep2 "[expr round((($u-$gcj)/60)/60)]h:[expr round(fmod((($u-$gcj)/60),60))]m" rep2} else {
       regsub -all "!!DUR" $rep2 "N/A" rep2
      }
      regsub -all "!!IDLE" $rep2 "[getchanidle $n $c]m" rep2
      puts $html [join [join $rep2]]
     } 
     continue
    }
    top* {
     if {$width == 0 || $amount == 0} {
      putlog "CHATstats: Syntax error in $input, must be: <!-- $what WidthOfBar,Amount -->"
      continue
     }
     set total 0
     switch -exact $what {
      topjoiners {set sortfor 2}  topvisitors {set sortfor 3} toptalkers {set sortfor 4}
      topallstars {set sortfor 6} topkickers {set sortfor 8}  topbanners {set sortfor 9}
      topkicked {set sortfor 10}  topbanned {set sortfor 11}  topidlers {set sortfor 13}
      default {putlog "Unknown identifier found in template: $what - Aborting"; return}
     }
     foreach e [array names csu] {if {[string match *$c $e]} {lappend list "[lindex $csu($e) 0] [lindex $csu($e) $sortfor]"}}
     if {$list != ""} {set list [lsort -integer -decreasing -index 1 $list]} else {continue}
     foreach e $list {incr total [lindex $e 1]}; if {$total == 0} {continue}
     set max [expr ([lindex [lindex $list 0] 1] * 100.0)/$total]; set i 1
     foreach e $list {
      set int [lindex $e 1]; if {$int == 0 || $i > $amount} {continue}
      set x [expr ($int * 100.0)/$total]; regexp {\d{1,3}\..{1}} $x x
      set barlength [expr int($x * ($width / $max) + ($x / 10))]
      regsub -all "!!RANK" $rep1 $i rep2
      regsub -all "!!USER" $rep2 [lindex $e 0] rep2
      if {$what == "topvisitors" || $what == "topidlers"} {regsub -all "!!VALUE" $rep2 [cs:duration $int] rep2} else {
       regsub -all "!!VALUE" $rep2 [cs:format $int] rep2
      }
      regsub -all "!!PERCENT" $rep2 "${x}%" rep2
      regsub -all "!!WIDTH" $rep2 $barlength rep2
      puts $html [cs:defilter [join [join $rep2]]]; incr i
     }
     continue
    }
    default {puts $html $l}
   }
  }
  puts $html $l
 }
 close $html; close $fid
}

proc cs:checkpeak {c} {
 global cs csc
 set i [lindex $csc($c) 4]; set j [llength [chanlist $c]]
 if {$j > $i} {
  putserv "PRIVMSG $c :New peak for $c @ $j users! Old peak was $i users on [cs:date $c peak]."
  cs:changevars $c; set csc($c) [lreplace $csc($c) 4 4 $j]; set csc($c) [lreplace $csc($c) 5 5 [unixtime]]; cs:save
 }
}

proc cs:date {c what} {
 global cs csc
 switch -exact $what {
  sta {if {[lindex $csc($c) 1] == 0} {return "N/A"} else {return [strftime "%d.%m.%Y" [expr [lindex $csc($c) 1] + $cs(timebalance) * 3600]]}}
  sto {if {[lindex $csc($c) 2] == 0} {return "N/A"} else {return [strftime "%d.%m.%Y" [expr [lindex $csc($c) 2] + $cs(timebalance) * 3600]]}}
  lr {if {[lindex $csc($c) 3] == 0} {return "N/A"} else {return [strftime "%d.%m.%Y" [expr [lindex $csc($c) 3] + $cs(timebalance) * 3600]]}}
  peak {if {[lindex $csc($c) 5] == 0} {return "N/A"} else {return [strftime "%d.%m.%Y" [expr [lindex $csc($c) 5] + $cs(timebalance) * 3600]]}}
  admyhm {return [strftime "%A, %d.%m.%Y, %H:%M" [expr [unixtime] + $cs(timebalance) * 3600]]}
 }
}

proc cs:reset {w} {
 global cs csu
 set jtime [lindex $csu($w) 1]; set u [unixtime]; set nic [lindex [split $w #] 0]
 set c "#[lindex [split $w #] 1]"; set ls [lindex $csu($w) 12]; set idle 0
 if {$jtime > 0} {
  set csu($w) [lreplace $csu($w) 3 3 [expr [lindex $csu($w) 3] + ($u - $jtime)]]
  set csu($w) [lreplace $csu($w) 1 1 0]
  if {$ls > 0} {set idle [expr $u - $ls]} else {set idle [expr $u - $jtime]}
  } else {
  if {$ls > 0} {set idle [expr $u - $ls]}
 }
 set csu($w) [lreplace $csu($w) 12 12 0]
 if {$idle > $cs(idle)} {set csu($w) [lreplace $csu($w) 13 13 [expr [lindex $csu($w) 13] + $idle]]}
}

proc cs:duration {du} {
 set o ""; set i [expr int($du/31536000)]; if {$i > 0} {lappend o "${i}y"}
 set i [expr int(fmod($du,31536000)/86400)]; if {$i > 0} {lappend o "${i}d"}
 set i [expr int(fmod($du,86400)/3600)]; if {$i > 0} {lappend o "${i}h"}
 set i [expr int(fmod($du,3600)/60)]; if {$i > 0} {lappend o "${i}m"}
 # set i [expr int(fmod($du,60))]; if {$i > 0} {lappend o "${i}s"}
 if {$o == ""} {return "N/A"} else {return [join $o ":"]}
}

proc cs:changevars {c} {
 global cs
 foreach e $cs(global) {set cs([lindex [split $e =] 0]) [lindex [split $e "="] 1]}
 if {[info exists cs($c)]} {foreach e $cs($c) {set cs([lindex [split $e =] 0]) [lindex [split $e "="] 1]}}
}

proc cs:topic {n uh h c t} {
 global cs cst
 cs:changevars $c; if {$n == "\*"} {set n "Unknown"}; set cst($c) "$n on [cs:date $c admyhm]"
}

proc cs:filtertopic {n} {
 regsub -all {|||(([0-9])?([0-9])?(\,([0-9])?([0-9])?)?)?|([0-9A-F][0-9A-F])?} $n "" n; return $n
}

proc cs:filter {n} {
 regsub -all \\\\ $n !1 n; regsub -all \\\[ $n !2 n; regsub -all \\\] $n !3 n;  regsub -all \\\} $n !4 n
 regsub -all \\\{ $n !5 n; regsub -all \\\^ $n !6 n; regsub -all \\\" $n !7 n; return $n
}
proc cs:defilter {n} {
 regsub -all !1 $n \\ n; regsub -all !2 $n \[ n; regsub -all !3 $n \] n; regsub -all !4 $n \} n;
 regsub -all !5 $n \{ n; regsub -all !6 $n \^ n; regsub -all !7 $n \" n; return $n
}

proc cs:format {i} {
 if {![string is integer $i]} {return $i}
 while {[regsub {([0-9])([0-9]{3})($|\.)} $i {\1.\2} i]} {}; return $i
}

cs:ini